#########################
##     Lint Checks     ##
#########################
check:rubocop:
  stage: check
  image: ruby:3-alpine3.21
  before_script:
    - apk add build-base linux-headers
    - gem install bundler && bundle config without run && bundle install
  script:
    - rubocop --parallel
  only:
    - main
    - merge_requests
  except:
    - schedules
    - tags

check:yamllint:
  stage: check
  # Use an up to date image of yamllint that can handle unicode emojis
  image: pipelinecomponents/yamllint
  script:
    - yamllint .gitlab-ci.yml .gitlab/ci/
  only:
    - main
    - merge_requests
  except:
    - schedules
    - tags

check:eslint:
  stage: check
  image: node:alpine
  script:
    - npm install eslint@^7.0.0 --global
    - eslint './**/*.js'
  only:
    - main
    - merge_requests
  except:
    - schedules
    - tags

check:markdown:
  stage: check
  image: node:alpine
  script:
    - npm install markdownlint-cli --global
    - markdownlint --config .markdownlint.yml docs README.md
  only:
    refs:
      - main
      - merge_requests
    changes:
      - docs/*
  except:
    - schedules
    - tags

check:markdown-link-check:
  stage: check
  image:
    name: ghcr.io/tcort/markdown-link-check:3
    entrypoint: [""]
  script:
    - /src/markdown-link-check *.md docs/*.md
  only:
    refs:
      - main
      - merge_requests
  except:
    - schedules
    - tags
  retry: 2
